using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Callista.BuildLab.Core;
using Callista.BuildLab.Core.Model;

namespace Callista.BuildLab.AdminClient
{
    public partial class SelectorForm : Form
    {
        private IBuildTypeAdministration _buildTypeAdminProxy = null;

        private string _teamProject;
        public string SelectedTeamProject
        {
            get { return _teamProject; }
            set { _teamProject = value; }
        }

        private string _buildType;
        public string SelectedBuildType
        {
            get { return _buildType; }
            set { _buildType = value; }
        }

        public SelectorForm(string caption, IBuildTypeAdministration buildTypeAdminProxy)
        {
            InitializeComponent();

            _buildTypeAdminProxy = buildTypeAdminProxy;

            this.Text = caption;
        }

        private void SelectorForm_Load(object sender, EventArgs e)
        {
            TeamProjects.DataSource = _buildTypeAdminProxy.ListTeamProjects();
            TeamProjects.DisplayMember = "Name";
        }

        private void OK_Click(object sender, EventArgs e)
        {
            TeamProject teamProject = (TeamProject)TeamProjects.SelectedValue;
            BuildType buildType = (BuildType)BuildTypes.SelectedValue;
            
            if (buildType != null && teamProject != null)
            {
                _teamProject = teamProject.Name;
                _buildType = buildType.Name;
            } 
            
            this.Close();
        }

        private void Cancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void TeamProjects_SelectedIndexChanged(object sender, EventArgs e)
        {
            TeamProject teamProject = (TeamProject)TeamProjects.SelectedValue;
            if (teamProject != null)
            {
                BuildTypes.DataSource = _buildTypeAdminProxy.ListBuildTypes(teamProject.Name);
                BuildTypes.DisplayMember = "Name";
            }
        }
    }
}