using System;
using System.Collections.Generic;
using System.Text;
using Callista.BuildLab.Core;
using Callista.BuildLab.Core.Model;
using System.Diagnostics;

namespace Callista.BuildLab.ConsoleHost
{
    class Program
    {
        static void Main(string[] args)
        {
            BuildManager bm = new BuildManager();
            String controlCharacter = String.Empty;

            Console.WriteLine("TFSBuildLab console started.");
            bm.Start();
            Console.WriteLine("TFSBuildLab console initialized.");
            Console.WriteLine();
            Console.WriteLine("Available commands are (Q)uit / (P)ause / (R)esume");
            while(true)
            {
                switch (controlCharacter.ToUpper())
                {
                    case "P":
                    case "PAUSE":
                        bm.Pause();
                        Console.WriteLine("TFSBuildLab console is now paused.");
                        break;
                    case "R":
                    case "RESUME":
                        bm.Resume();
                        Console.WriteLine("TFSBuildLab console has now resumed.");
                        break;
                    case "Q":
                    case "QUIT":
                        bm.Stop();
                        Console.WriteLine("TFSBuildLab console stopped.");
                        return;
                }

                Console.Write(": ");
                controlCharacter = Console.ReadLine();
            }
        }
    }
}
