using System;
using System.Text;
using System.Configuration;
using System.Collections.Generic;

namespace Callista.BuildLab.Core.Data
{
    class Common
    {
        internal static String GetConnectionString() 
        {
            return ConfigurationManager.AppSettings["tfsBuildLabConnectionString"];
        }

        internal static Dictionary<string, string> DeserializeBuildParams(string parameters)
        {
            Dictionary<string, string> result = new Dictionary<string, string>();

            if (!string.IsNullOrEmpty(parameters))
            {
                foreach (string nvp in parameters.Split(';'))
                {
                    if (!string.IsNullOrEmpty(nvp))
                    {
                        string[] temp = nvp.Split('=');
                        if (!result.ContainsKey(temp[0]))
                        {
                            result.Add(temp[0], temp[1]);
                        }
                    }
                }
            }

            return result;
        }

        internal static List<string> DeserializeBuildServers(string data)
        {
            List<string> result = new List<string>();

            if (!string.IsNullOrEmpty(data))
            {
                string[] buffer = data.Split('|');
                if (buffer.Length > 1)
                {
                    foreach (string bs in buffer[1].Split(';'))
                    {
                        if (!string.IsNullOrEmpty(bs))
                        {
                            if (!result.Contains(bs))
                            {
                                result.Add(bs);
                            }
                        }
                    }
                }
            }

            return result;
        }

        internal static string SerializeBuildParams(Dictionary<string, string> parameters)
        {
            string result = "";

            foreach (string key in parameters.Keys)
            {
                result += key + "=" + parameters[key] + ";";
            }

            return result;
        }
        
        internal static string SerializeBuildServers(List<string> servers)
        {
            string result = "";
            
            foreach (string s in servers)
            {
                result += s + ";";
            }

            return result.TrimEnd(';');
        }

        internal static string ExtractTriggerPath(string data)
        {
            string result = "";

            if (!string.IsNullOrEmpty(data))
            {
                string[] buffer = data.Split('|');
                if (buffer.Length > 1)
                {
                    result = buffer[0];
                }
                else
                {
                    result = data;
                }
            }

            return result;
        }
    }
}
