using System;
using System.Text;
using System.Collections.Generic;

namespace Callista.BuildLab.Core.Model
{
    public enum BuildStatus
    {
        Any = -1,
        BuildRunning = 0,
        BuildSucceeded = 100,
        BuildFailed = 200,
        BuildStopped = 300,
    }

    public enum BuildQuality
    {
        Any = -1,
        Unexamined = 0,
	    UnderInvestigation = 2,
    	Released = 3,
    	Rejected = 4,
    	ReadyforInitialTest = 5,
        ReadyforDeployment = 6,
    	InitialTestPassed = 7,
    	LabTestPassed = 8,
        UserAcceptanceTestsPassed = 9 //UATPassed
    }

    public enum EventType
    {
        Error,
        Delete,
        QueueCheckin,
        QueueScheduled,
        StartScheduled,
        StartCheckin,
        RemoveScheduled,
        RemoveCheckin,
        UndeliverableScheduled,
        UndeliverableCheckin,
        CompletedScheduled,
        CompletedCheckin,
        FailedScheduled,
        FailedCheckin
    }

    public enum TriggerType
    {
        CheckinInclude,
        CheckinExclude,
        Schedule
    }

    public enum RetentionPolicyType
    {
        Builds,
        Days
    }

    public static class EnumConverter
    {
        public static BuildQuality ConvertToBuildQuality(string s)
        {
            switch (s)
            {
                case "Unexamined":
                    return BuildQuality.Unexamined;
                case "Under Investigation":
                    return BuildQuality.UnderInvestigation;
                case "Released":
                    return BuildQuality.Released;
                case "Rejected":
                    return BuildQuality.Rejected;
                case "Ready for Initial Test":
                    return BuildQuality.ReadyforInitialTest;
                case "Ready for Deployment":
                    return BuildQuality.ReadyforDeployment;
                case "Initial Test Passed":
                    return BuildQuality.InitialTestPassed;
                case "Lab Test Passed":
                    return BuildQuality.LabTestPassed;
                case "UAT Passed":
                    return BuildQuality.UserAcceptanceTestsPassed;
                default:
                    return BuildQuality.Any;
            }
        }
    }
}
