using System;
using System.Text;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace Callista.BuildLab.Core.Model
{
    [DataContract]
    public class LogEntry
    {
        private string _teamProject = string.Empty;
        private string _buildType = string.Empty;
        private DateTime _eventTime = DateTime.MinValue;
        private string _eventType = string.Empty;
        private string _triggeredBy = string.Empty;
        private string _buildUri = string.Empty;
        private string _message = string.Empty;

        public LogEntry(DateTime eventTime, string eventType, string teamProject, string buildType, string triggeredBy, string buildUri, string message)
        {
            _eventTime = eventTime;
            _eventType = eventType;
            _teamProject = teamProject;
            _buildType = buildType;
            _triggeredBy = triggeredBy;
            _buildUri = buildUri;
            _message = message;
        }

        [DataMember]
        public DateTime EventTime
        {
            get { return _eventTime; }
            set { _eventTime = value; }
        }

        [DataMember]
        public string EventType
        {
            get { return _eventType; }
            set { _eventType = value; }
        }

        [DataMember]
        public string TeamProject
        {
            get { return _teamProject; }
            set { _teamProject = value; }
        }

        [DataMember]
        public string BuildType
        {
            get { return _buildType; }
            set { _buildType = value; }
        }

        [DataMember]
        public string TriggeredBy
        {
            get { return _triggeredBy; }
            set { _triggeredBy = value; }
        }

        [DataMember]
        public string BuildUri
        {
            get { return _buildUri; }
            set { _buildUri = value; }
        }

        [DataMember]
        public string Message
        {
            get { return _message; }
            set { _message = value; }
        }
    }
}
