using System;
using System.Text;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace Callista.BuildLab.Core.Model
{
    [DataContract]
    public class QueueEntry
    {
        private int _id = 0;
        private string _teamProjectName = string.Empty;
        private string _buildTypeName = string.Empty;
        private string _buildServer = string.Empty;
        private string _triggeringUser = string.Empty;
        private Nullable<int> _triggeringChangesetID = new Nullable<int>();
        private List<Changeset> _involvedChangesets = new List<Changeset>();
        private Dictionary<string, string> _overriddenParameters = new Dictionary<string, string>();

        public QueueEntry(string teamProject, string buildType, string buildServer)
        {
            _teamProjectName = teamProject;
            _buildTypeName = buildType;
            _buildServer = buildServer;
        }

        public QueueEntry(string teamProject, string buildType, string buildServer, string triggeringUser, Dictionary<string, string> parameters)
        {
            _teamProjectName = teamProject;
            _buildTypeName = buildType;
            _buildServer = buildServer;
            _triggeringUser = triggeringUser;
            _overriddenParameters = parameters;
        }

        public QueueEntry(string teamProject, string buildType, string buildServer, string triggeringUser, Nullable<int> triggeringChangesetID, Dictionary<string, string> parameters)
        {
            _teamProjectName = teamProject;
            _buildTypeName = buildType;
            _buildServer = buildServer;
            _triggeringUser = triggeringUser;
            _triggeringChangesetID = triggeringChangesetID;
            _overriddenParameters = parameters;
        }

        public QueueEntry(int id, string teamProject, string buildType, string buildServer, string triggeringUser, Nullable<int> triggeringChangesetID, Dictionary<string,string> parameters)
        {
            _id = id;
            _teamProjectName = teamProject;
            _buildTypeName = buildType;
            _buildServer = buildServer;
            _triggeringUser = triggeringUser;
            _triggeringChangesetID = triggeringChangesetID;
            _overriddenParameters = parameters;
        }

        [DataMember]
        public int ID
        {
            get { return _id; }
            set { _id = value; }
        }

        [DataMember]
        public string TeamProjectName
        {
            get { return _teamProjectName; }
            set { _teamProjectName = value; }
        }

        [DataMember]
        public string BuildTypeName
        {
            get { return _buildTypeName; }
            set { _buildTypeName = value; }
        }

        [DataMember]
        public string BuildServer
        {
            get { return _buildServer; }
            set { _buildServer = value; }
        }

        [DataMember]
        public string TriggeringUser
        {
            get { return _triggeringUser; }
            set { _triggeringUser = value; }
        }

        [DataMember]
        public Nullable<int> TriggeringChangesetID
        {
            get { return _triggeringChangesetID; }
            set { _triggeringChangesetID = value; }
        }

        public List<Changeset> InvolvedChangesets
        {
            get { return _involvedChangesets; }
            set { _involvedChangesets = value; }
        }

        [DataMember]
        public Dictionary<string, string> OverriddenBuildParameters
        {
            get { return _overriddenParameters; }
            set { _overriddenParameters = value; }
        }
    }
}
