using System;
using System.Text;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using Microsoft.TeamFoundation.Build.Proxy;

namespace Callista.BuildLab.Core.Model
{
    [DataContract]
    public class TeamBuild
    {
        private BuildData _buildData;

        private string _buildNumber;
        private string _buildType;
        private string _buildUri;
        private string _buildMachine;
        private BuildStatus _buildStatus;
        private BuildQuality _buildQuality;
        private string _requestedBy;
        private DateTime _started;
        private DateTime _finnished;

        public TeamBuild(BuildData buildData)
        {
            _buildData = buildData;
            _buildNumber = _buildData.BuildNumber;
            _buildType = _buildData.BuildType;
            _buildUri = _buildData.BuildUri;
            _buildMachine = _buildData.BuildMachine;
            _finnished = _buildData.FinishTime;
            _started = _buildData.StartTime; 
            _requestedBy = _buildData.RequestedBy; 
            _buildStatus = (BuildStatus)_buildData.BuildStatusId; 
            _buildQuality = EnumConverter.ConvertToBuildQuality(_buildData.BuildQuality);
        }

        [DataMember]
        public string BuildUri
        {
            get { return _buildUri; }
            set { _buildUri = value; }
        }

        [DataMember]
        public string BuildMachine
        {
            get { return _buildMachine; }
            set { _buildMachine = value; }
        }

        [DataMember]
        public string BuildNumber
        {
            get { return _buildNumber; }
            set { _buildNumber = value; }
        }

        [DataMember]
        public string BuildType
        {
            get { return _buildType; }
            set { _buildType = value; }
        }

        public string DropLocation
        {
            get { return _buildData.DropLocation; }
        }

        [DataMember]
        public DateTime FinishTime
        {
            get { return _finnished; }
            set { _finnished = value; }
        }

        [DataMember]
        public DateTime StartTime
        {
            get { return _started; }
            set { _started = value; }
        }

        [DataMember]
        public string RequestedBy
        {
            get { return _requestedBy; }
            set { _requestedBy = value; }
        }

        public string LastChangedBy
        {
            get { return _buildData.LastChangedBy; }
        }

        public DateTime LastChangedOn
        {
            get { return _buildData.LastChangedOn; }
        }

        public string LogLocation
        {
            get { return _buildData.LogLocation; }
        }

        [DataMember]
        public BuildStatus Status
        {
            get { return _buildStatus; }
            set { _buildStatus = value; }
        }

        [DataMember]
        public BuildQuality Quality
        {
            get { return _buildQuality; }
            set { _buildQuality = value; }
        }
    }
}
