using System;
using System.Text;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace Callista.BuildLab.Core.Model
{
    [DataContract]
    public class Trigger
    {
        private BuildType _parent;
        private int _id = 0;
        private TriggerType  _type;
        private string _data;
        private List<string> _servers = new List<string>();
        private Dictionary<string, string> _params = new Dictionary<string, string>();

        public BuildType Parent
        {
            get { return _parent; }
        }

        [DataMember]
        public int ID
        {
            get { return _id; }
            set { _id = value; }
        }

        [DataMember]
        public TriggerType Type
        {
            get { return _type; }
            set { _type = value; }
        }

        [DataMember]
        public string Data
        {
            get { return _data; }
            set { _data = value; }
        }

        [DataMember]
        public List<string> Servers
        {
            get { return _servers; }
            set { _servers = value; }
        }

        [DataMember]
        public Dictionary<string, string> Parameters
        {
            get { return _params; }
            set { _params = value; }
        }

        public Trigger(TriggerType type, string data, List<string> servers, Dictionary<string, string> parameters)
        {
            this._type = type;
            this._data = data;
            this._servers = servers;
            this._params = parameters;
        }

        public Trigger(BuildType parent, int id, TriggerType type, string data, List <string> servers, Dictionary<string, string> parameters)
        {
            this._parent = parent;
            this._id = id;
            this._type = type;
            this._data = data;
            this._servers = servers;
            this._params = parameters;
        }
    }
}
