using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace Callista.BuildLab.Core.Model
{
    [DataContract]
    public class WorkspaceMapping
    {
        private List<string> _mappedPaths = new List<string>();
        private List<string> _cloakedPaths = new List<string>();

        [DataMember]
        public List<string> MappedPaths
        {
            get { return _mappedPaths; }
            set { _mappedPaths = value; }
        }

        [DataMember]
        public List<string> CloakedPaths
        {
            get { return _cloakedPaths; }
            set { _cloakedPaths = value; }
        }

        public bool IsMatching(Changeset cs)
        {
            foreach (VersionedItem vi in cs.VersionedItems)
            {
                //Currently there is no need to look in the cloaked paths any match 
                //in the mapped paths needs to trigger a build
                foreach (string path in _mappedPaths)
                {
                    if (vi.Folder.StartsWith(path, true, System.Globalization.CultureInfo.CurrentCulture))
                    {
                        return true;
                    }
                }
            }

            return false;
        }
    }
}
