PRINT N'Creating [dbo].[BuildType_UpdateRetentionPolicy]'
GO

CREATE Procedure [dbo].[BuildType_UpdateRetentionPolicy] 
	( 
	@ID [int], 
	@BuildStatus [nvarchar](16), 
	@PolicyType [nvarchar](16), 
	@Quantity [int] 
	) 
AS 
	UPDATE RetentionPolicy SET BuildStatus=@BuildStatus,PolicyType=@PolicyType,Quantity=@Quantity WHERE ID=@ID 

GO

PRINT N'Creating [dbo].[BuildType_CopyConfig]'
GO

CREATE Procedure [dbo].[BuildType_CopyConfig] 
	( 
	@SrcTeamProject [nvarchar](128), 
	@SrcBuildType [nvarchar](128), 
	@DstTeamProject [nvarchar](128), 
	@DstBuildType [nvarchar](128) 
	) 
AS 
 
INSERT INTO [RetentionPolicy] (TeamProject,BuildType,BuildStatus,PolicyType,Quantity)  
	SELECT @DstTeamProject,@DstBuildType,BuildStatus,PolicyType,Quantity 
	FROM [RetentionPolicy]  
	WHERE TeamProject=@SrcTeamProject AND BuildType=@SrcBuildType 
 
INSERT INTO [Trigger] (TeamProject,BuildType,Type,Data)  
	SELECT @DstTeamProject,@DstBuildType,Type,Data 
	FROM [Trigger]  	 
	WHERE TeamProject=@SrcTeamProject AND BuildType=@SrcBuildType 
 
GO

PRINT N'Creating [dbo].[BuildType_UpdateTrigger]'
GO
 
CREATE Procedure [dbo].[BuildType_UpdateTrigger] 
	( 
	@ID [int], 
	@TriggerType [nvarchar](16), 
	@Data [nvarchar](256) 
	) 
AS 
	UPDATE [Trigger] SET [Type]=@TriggerType,[Data]=@Data WHERE ID=@ID 
 
GO

PRINT N'Creating [dbo].[Queue_Count]'
GO

CREATE Procedure [dbo].[Queue_Count] 
AS 
	SELECT Count(*) AS QueueEntries FROM Queue

GO

PRINT N'Altering [dbo].[Queue_Peek]'
GO

ALTER Procedure [dbo].[Queue_Peek] 
	( 
	@ID [int] = NULL 
	) 
AS 

	DECLARE @nextID int

	IF @ID IS NULL  
	BEGIN 
		SELECT @nextID = MIN(ID) FROM Queue	 
	END 
	ELSE  
	BEGIN 
		SELECT @nextID = MIN(ID) FROM Queue	WHERE ID > @ID 
	END 

	IF @nextID = @ID
	BEGIN
		SET @nextID = NULL
	END
	 
	SELECT ID,TeamProject,BuildType,BuildServer,TriggeringChangeset,TriggeringUser,AssosiatedBuildParams FROM Queue WHERE ID = @nextID 

GO

PRINT N'Altering permissions on [dbo].[BuildType_UpdateTrigger]'
GO
GRANT EXECUTE ON  [dbo].[BuildType_UpdateTrigger] TO [TFSBuildLab]
GO

PRINT N'Altering permissions on [dbo].[BuildType_UpdateRetentionPolicy]'
GO
GRANT EXECUTE ON  [dbo].[BuildType_UpdateRetentionPolicy] TO [TFSBuildLab]
GO

PRINT N'Altering permissions on [dbo].[BuildType_CopyConfig]'
GO
GRANT EXECUTE ON  [dbo].[BuildType_CopyConfig] TO [TFSBuildLab]
GO