using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Callista.BuildLab.Core;
using Callista.BuildLab.Core.Model;

namespace Callista.BuildLab.NotifyClient
{
    public partial class StatusForm : Form
    {
        public StatusForm()
        {
            InitializeComponent();
        }

        private void StatusForm_SizeChanged(object sender, EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.Close();
            }
        }

        private void StatusForm_Load(object sender, EventArgs e)
        {
            List<TeamBuild> builds = new List<TeamBuild>();
            builds.AddRange(Program.MonitoredBuilds.Values);

            List<CheckinEvent> checkins = new List<CheckinEvent>();
            checkins.AddRange(Program.LatestCheckinEvents);

            CheckinGridView.Columns.Add("Changeset", "Changeset");
            CheckinGridView.Columns.Add("Project", "Project");
            CheckinGridView.Columns.Add("Committer", "Committed by");
            CheckinGridView.Columns.Add("Comment", "Comment");
            CheckinGridView.Columns["Changeset"].DataPropertyName = "Number";
            CheckinGridView.Columns["Project"].DataPropertyName = "TeamProject";
            CheckinGridView.Columns["Committer"].DataPropertyName = "Committer";
            CheckinGridView.Columns["Comment"].DataPropertyName = "Comment";
            CheckinGridView.AutoGenerateColumns = false;
            CheckinGridView.DataSource = checkins;

            BuildTypeGridView.Columns.Add("BuildType", "BuildType");
            BuildTypeGridView.Columns.Add("BuildMachine", "BuildMachine");
            BuildTypeGridView.Columns.Add("BuildStatus", "BuildStatus");
            BuildTypeGridView.Columns.Add("Requester", "Requested by");
            BuildTypeGridView.Columns.Add("Finnished", "Finnished");
            BuildTypeGridView.Columns["BuildType"].DataPropertyName = "BuildType";
            BuildTypeGridView.Columns["BuildMachine"].DataPropertyName = "BuildMachine";
            BuildTypeGridView.Columns["BuildStatus"].DataPropertyName = "Status";
            BuildTypeGridView.Columns["Requester"].DataPropertyName = "RequestedBy";
            BuildTypeGridView.Columns["Finnished"].DataPropertyName = "FinishTime";
            BuildTypeGridView.AutoGenerateColumns = false;
            BuildTypeGridView.DataSource = builds;
        }
    }
}