﻿using System;
using System.Text;
using System.Collections.Generic;
using Callista.BuildLab.Core.Model;
using Microsoft.TeamFoundation.Build;
using Microsoft.TeamFoundation.Build.Proxy;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Callista.BuildLab.UnitTests
{
    [TestClass()]
    public class RetentionPolicyTest
    {
        [TestMethod()]
        public void EvaluateRetentionPolicyTest_NumberOfBuilds_KeepOneFailed()
        {
            BuildData data = null;
            List<TeamBuild> builds = new List<TeamBuild>();

            data = new BuildData();
            data.BuildStatus = "Successfull Completed";
            data.FinishTime = DateTime.Now.AddDays(-1).AddHours(-2);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Successfull Completed";
            data.FinishTime = DateTime.Now.AddDays(-1).AddHours(-1);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Failed";
            data.FinishTime = DateTime.Now.AddHours(-3);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Failed";
            data.FinishTime = DateTime.Now.AddHours(-1);
            builds.Add(new TeamBuild(data));
            
            //RetentionPolicy policy = new RetentionPolicy(BuildResultStatus.Failed, RetentionPolicyType.Builds, 1);
            //policy.EnforceRetentionPolicy(builds);

            //TODO how should we test this when no value is returned?

            Assert.Inconclusive("Tests needs rewriting due to changes in obj model");

            //Assert.AreEqual(1,result.Count);
            //Assert.AreSame(builds[1],result.Values[0]);
        }

        [TestMethod()]
        public void EvaluateRetentionPolicyTest_NumberOfDays_KeepOneFailed()
        {
            BuildData data = null;
            List<TeamBuild> builds = new List<TeamBuild>();

            data = new BuildData();
            data.BuildStatus = "Successfull Completed";
            data.FinishTime = DateTime.Now.AddDays(-1).AddHours(-2);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Failed";
            data.FinishTime = DateTime.Now.AddDays(-3);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Successfull Completed";
            data.FinishTime = DateTime.Now.AddDays(-1).AddHours(-1);
            builds.Add(new TeamBuild(data));

            data = new BuildData();
            data.BuildStatus = "Failed";
            data.FinishTime = DateTime.Now.AddDays(-1);
            builds.Add(new TeamBuild(data));

            //RetentionPolicy policy = new RetentionPolicy(BuildResultStatus.Failed, RetentionPolicyType.Days, 2);
            //policy.EnforceRetentionPolicy(builds);

            //TODO how should we test this when no value is returned?

            Assert.Inconclusive("Tests needs rewriting due to changes in obj model");

            //Assert.AreEqual(1,result.Count);
            //Assert.AreSame(builds[3], result.Values[0]);
        }
    }


}
